package sun.java2d.loops;

import sun.java2d.pipe.Region;
import java.awt.Composite;
import sun.java2d.SurfaceData;

public class ScaledBlit extends GraphicsPrimitive
{
    public static final String methodSignature;
    public static final int primTypeID;
    private static RenderCache blitcache;
    
    public static ScaledBlit locate(SurfaceType surfaceType, CompositeType compositeType, SurfaceType surfaceType2) {
        return (ScaledBlit)GraphicsPrimitiveMgr.locate(ScaledBlit.primTypeID, surfaceType, compositeType, surfaceType2);
    }
    
    public static ScaledBlit getFromCache(SurfaceType surfaceType, CompositeType compositeType, SurfaceType surfaceType2) {
        Object value = ScaledBlit.blitcache.get(surfaceType, compositeType, surfaceType2);
        if (value != null) {
            return (ScaledBlit)value;
        }
        ScaledBlit locate = locate(surfaceType, compositeType, surfaceType2);
        if (locate == null) {
            return locate;
        }
        ScaledBlit.blitcache.put(surfaceType, compositeType, surfaceType2, locate);
        return locate;
    }
    
    protected ScaledBlit(SurfaceType surfaceType, CompositeType compositeType, SurfaceType surfaceType2) {
        super(ScaledBlit.methodSignature, ScaledBlit.primTypeID, surfaceType, compositeType, surfaceType2);
    }
    
    public ScaledBlit(long n, SurfaceType surfaceType, CompositeType compositeType, SurfaceType surfaceType2) {
        super(n, ScaledBlit.methodSignature, ScaledBlit.primTypeID, surfaceType, compositeType, surfaceType2);
    }
    
    public native void Scale(SurfaceData p0, SurfaceData p1, Composite p2, Region p3, int p4, int p5, int p6, int p7, double p8, double p9, double p10, double p11);
    
    @Override
    public GraphicsPrimitive makePrimitive(SurfaceType surfaceType, CompositeType compositeType, SurfaceType surfaceType2) {
        return null;
    }
    
    @Override
    public GraphicsPrimitive traceWrap() {
        return new ScaledBlit.TraceScaledBlit(this);
    }
    
    static {
        methodSignature = "ScaledBlit(...)".toString();
        primTypeID = GraphicsPrimitive.makePrimTypeID();
        ScaledBlit.blitcache = new RenderCache(20);
        GraphicsPrimitiveMgr.registerGeneral(new ScaledBlit(null, null, null));
    }
    
    private static class TraceScaledBlit extends ScaledBlit
    {
        ScaledBlit target;
        
        public TraceScaledBlit(ScaledBlit target) {
            super(target.getSourceType(), target.getCompositeType(), target.getDestType());
            this.target = target;
        }
        
        @Override
        public GraphicsPrimitive traceWrap() {
            return this;
        }
        
        @Override
        public void Scale(SurfaceData surfaceData, SurfaceData surfaceData2, Composite composite, Region region, int n, int n2, int n3, int n4, double n5, double n6, double n7, double n8) {
            GraphicsPrimitive.tracePrimitive(this.target);
            this.target.Scale(surfaceData, surfaceData2, composite, region, n, n2, n3, n4, n5, n6, n7, n8);
        }
    }
}
